#!/bin/sh
dist_loss=0
supp_loss=0
for i in `cat $1`
do
	echo
	echo `fgrep $i etc/sdc_train.transcription` | sed -e"s/<s> //" | sed -e"s/<\/s> //" > etc/sdc_test.transcription
	echo -n "Target: "
	echo `cat etc/sdc_test.transcription`
	echo "corpus_test/$i" > etc/sdc_test.fileids
	cp wav/corpus_train/$i.wav wav/corpus_test/$i.wav
	chmod 644 wav/corpus_test/$i.wav
	while read start stop words
	do
		echo -n "Distorting ["
		echo -n $words
		echo "]"

		cp wav/corpus_test/$i.wav wav/corpus_test/$i.wav.before
		perl scripts_pl/make_feats.pl -ctl etc/sdc_test.fileids > /dev/null 2>&1 
		perl scripts_pl/decode/slave.pl > /dev/null 2>&1 
		clean_wer=$?

		cp wav/corpus_test/$i.wav wav/corpus_test/$i.s.wav 
		distort wav/corpus_test/$i.s.wav wav/corpus_test/$i.s.wav $start $stop supress  > /dev/null 2>&1 
		sub wav/corpus_test/$i.wav wav/corpus_test/$i.s.wav  > /dev/null 2>&1 
		supp_diff=$?

		mv wav/corpus_test/$i.s.wav wav/corpus_test/$i.wav
		perl scripts_pl/make_feats.pl -ctl etc/sdc_test.fileids > /dev/null 2>&1 
		perl scripts_pl/decode/slave.pl > /dev/null 2>&1
		supp_wer=$?

		echo -n "Clean WER% = "
		echo -n $clean_wer
		echo -n "	Suppressed WER% = "
		echo -n $supp_wer
		echo -n "	Supression RMSD = "
		echo $supp_diff


		dist_incr=500
		dist_level=1000
		dist_wer=0
		dist_diff=0
		echo "    DISTLEVEL	RMSD	WER%	RECOGNIZER OUTPUT"
		while [ $dist_wer -lt $supp_wer ] && [ $dist_wer -le $clean_wer ] && [ $dist_diff -lt $supp_diff ]
		do

			echo -n "	"
			echo -n $dist_level

			cp wav/corpus_test/$i.wav.before wav/corpus_test/$i.d.wav
			distort wav/corpus_test/$i.d.wav wav/corpus_test/$i.d.wav $start $stop distort $dist_level  > /dev/null 2>&1 
			cp wav/corpus_test/$i.wav.before wav/corpus_test/$i.wav
			sub wav/corpus_test/$i.wav wav/corpus_test/$i.d.wav  > /dev/null 2>&1 
			dist_diff=$?
			echo -n "	"
			echo -n $dist_diff

			mv wav/corpus_test/$i.d.wav wav/corpus_test/$i.wav
			perl scripts_pl/make_feats.pl -ctl etc/sdc_test.fileids > /dev/null 2>&1 
			perl scripts_pl/decode/slave.pl > /dev/null 2>&1 
			dist_wer=$?
			echo -n "	"
			echo -n $dist_wer

			dist_level=`expr $dist_level "+" $dist_incr`

			echo -n "	"
			fgrep "HYP:" result/sdc.align

		done
		dist_loss=`expr $dist_loss "+" $dist_diff`
		supp_loss=`expr $supp_loss "+" $supp_diff`


	done<lab/corpus_test/$i.lab

	rm -f wav/corpus_test/$i.wav.before

done

echo
echo -n "Total RMSD from  distortion = "
echo $dist_loss
echo -n "Total RMSD from suppression = "
echo $supp_loss

